from setuphelpers import *
import json
import re
import requests
import datetime


def update_package():
    # Déclarer les variables locales
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name

    # Obtenir la dernière version depuis les sources officielles
    url = "https://www.swi-prolog.org/download/stable/bin/"
    index = wgets(url, proxies=proxies)
    if not index:
        print("Error: Unable to fetch the index page.")
        return package_updated

    # Pattern pour trouver les fichiers .exe
    re_versions = re.compile(r'swipl-(\d+\.\d+\.\d+-\d+)\.x86\.exe')
    files = []

    # Extraire les liens et les versions
    for a in bs_find_all(index, 'a', href=True):
        href = a['href']
        match = re_versions.match(href)
        if match:
            version = match.group(1)
            files.append((href, version))
            print(f"Found file: {href} with version: {version}")

    # Trouver le fichier le plus récent
    if files:
        # Trier par version en utilisant une fonction personnalisée
        def version_key(version_str):
            return list(map(int, version_str.split('-')[0].split('.')))

        latest_bin, latest_version = max(files, key=lambda x: version_key(x[1]))
        #Enlever l'extension .envelope pour obtenir le nom de fichier correct
        latest_bin = latest_bin.replace('.envelope', '')
        download_url = f"{url}{latest_bin}"

        if not requests.head(download_url, proxies=proxies).status_code == 404:
            print(f"Latest version: {latest_version}")
            print(f"Download URL: {download_url}")
        # remove files
        for f in glob.glob("*.exe"):
            if f != latest_bin:
                remove_file(f)

        # Downloading latest binaries
        wget(download_url, latest_bin, proxies=proxies)

        control.set_software_version(version)
        control.save_control_to_wapt()